# Generated by ariadne-codegen
# Source: queries.graphql

from typing import Any, List, Optional

from pydantic import Field

from .base_model import BaseModel
from .enums import AlgoRunningStatus, MMAlgoKind, ReferencePrice


class GetMmStatus(BaseModel):
    mm_algo_status: List["GetMmStatusMmAlgoStatus"] = Field(alias="mmAlgoStatus")


class GetMmStatusMmAlgoStatus(BaseModel):
    order_id: Any = Field(alias="orderId")
    order: Optional["GetMmStatusMmAlgoStatusOrder"]
    creation_time: Any = Field(alias="creationTime")
    status: AlgoRunningStatus
    position: Any
    hedge_position: Any = Field(alias="hedgePosition")
    miss_ratio: Any = Field(alias="missRatio")
    effective_spread: Optional[Any] = Field(alias="effectiveSpread")
    buy_status: "GetMmStatusMmAlgoStatusBuyStatus" = Field(alias="buyStatus")
    sell_status: "GetMmStatusMmAlgoStatusSellStatus" = Field(alias="sellStatus")
    kind: MMAlgoKind


class GetMmStatusMmAlgoStatusOrder(BaseModel):
    name: str
    order_id: Any = Field(alias="orderId")
    market_id: Any = Field(alias="marketId")
    quantity_buy: Any = Field(alias="quantityBuy")
    quantity_sell: Any = Field(alias="quantitySell")
    min_position: Any = Field(alias="minPosition")
    max_position: Any = Field(alias="maxPosition")
    max_improve_bbo: Any = Field(alias="maxImproveBbo")
    position_tilt: Any = Field(alias="positionTilt")
    reference_price: ReferencePrice = Field(alias="referencePrice")
    ref_dist_frac: Any = Field(alias="refDistFrac")
    tolerance_frac: Any = Field(alias="toleranceFrac")
    account: Optional[Any]


class GetMmStatusMmAlgoStatusBuyStatus(BaseModel):
    last_order_time: Any = Field(alias="lastOrderTime")
    last_fill_time: Any = Field(alias="lastFillTime")
    last_reject_time: Any = Field(alias="lastRejectTime")
    open_order: Optional["GetMmStatusMmAlgoStatusBuyStatusOpenOrder"] = Field(
        alias="openOrder"
    )
    reference_price: Optional[Any] = Field(alias="referencePrice")


class GetMmStatusMmAlgoStatusBuyStatusOpenOrder(BaseModel):
    order_id: Any = Field(alias="orderId")
    price: Any
    quantity: Any
    cancel_pending: bool = Field(alias="cancelPending")


class GetMmStatusMmAlgoStatusSellStatus(BaseModel):
    last_order_time: Any = Field(alias="lastOrderTime")
    last_fill_time: Any = Field(alias="lastFillTime")
    last_reject_time: Any = Field(alias="lastRejectTime")
    open_order: Optional["GetMmStatusMmAlgoStatusSellStatusOpenOrder"] = Field(
        alias="openOrder"
    )
    reference_price: Optional[Any] = Field(alias="referencePrice")


class GetMmStatusMmAlgoStatusSellStatusOpenOrder(BaseModel):
    order_id: Any = Field(alias="orderId")
    price: Any
    quantity: Any
    cancel_pending: bool = Field(alias="cancelPending")


GetMmStatus.model_rebuild()
GetMmStatusMmAlgoStatus.model_rebuild()
GetMmStatusMmAlgoStatusBuyStatus.model_rebuild()
GetMmStatusMmAlgoStatusSellStatus.model_rebuild()
